clear all;
close all;
clc;

fc = 30e9;
c = 3e8;
lambda = c/fc;



Nt= 256;
Nr = 256;
N_RF_digital = 256;
plot_point1 = 40;
plot_point2 = 160;

begin_point = 0.5;
mid_point = 6;
end_point = 500;

D_list = [linspace(begin_point,mid_point,plot_point1),linspace(mid_point,end_point,plot_point2)];
SNR_db = -15;
SNR = 10^(SNR_db/10);
thre = 0.94;

d_near = 2*(Nt*lambda/2)*(Nr*lambda/2)/lambda;

[~, d_len] = size(D_list);
H = generate_ULA_parallel_new(fc, Nt, Nr,D_list);
%% channel DoF calculation
N_cal = zeros(1,d_len);
power_tot = zeros(1,d_len);
eigen_value = zeros(d_len,Nr);
for i_d = 1:d_len
    if i_d == 143
        aa = 1;
    end
    H_tmp = squeeze(H(i_d, :,:));
    [~, S, ~] = svd(H_tmp);
    eigen_value(i_d, :) = abs(diag(S));
    power_tot(i_d) = sum(eigen_value(i_d,:).*eigen_value(i_d,:));
    
    power_cnt = 0;
    eig_cnt = 0;
    for i_cnt = 1:Nt
        if power_cnt < thre*power_tot(i_d)
            power_cnt = power_cnt+eigen_value(i_d,i_cnt)^2;
            eig_cnt = eig_cnt+1;
        else
            break;
        end
    end
    N_cal(i_d) = eig_cnt;
end

%% channel DoF rough estimation 
N_est1 = zeros(1,d_len);
for i_d = 1:d_len
    H_tmp = squeeze(H(i_d, :,:));
    N_est1(i_d) = (Nt-1)*(Nr-1)*(lambda/2)^2/lambda/D_list(i_d);
end

%% channel DoF  accurate estimation
N_est2 = zeros(1,d_len);
for i_d = 1:d_len
    H_tmp = squeeze(H(i_d, :,:));
    N_est2(i_d) = 1+(2*(Nt-1)*(Nr-1)*(lambda/2)^2/lambda/sqrt(4*D_list(i_d)^2+(Nr-1)^2*(lambda/2)^2));
end

figure1 = figure;
idx = 1:10:plot_point1;
idx = [idx, plot_point1:20:plot_point1+plot_point2];

h1 = semilogy(D_list,abs(N_cal),'-','color','k','LineWidth',1.5);
hold on;
h1_1 = semilogy(D_list(idx),abs(N_cal(idx)),'^','color','k','LineWidth',1.5);
h1_2 = semilogy(D_list(1),abs(N_cal(1)),'-^','color','k','LineWidth',1.5);


h2 = semilogy(D_list,abs(N_est1),'-','color',[0 0.4470 0.7410],'LineWidth',1.5);
h2_1 = semilogy(D_list(idx),abs(N_est1(idx)),'x','color',[0 0.4470 0.7410],'LineWidth',1.5);
h2_2 = semilogy(D_list(1),abs(N_est1(1)),'-x','color',[0 0.4470 0.7410],'LineWidth',1.5);
h3 = semilogy(D_list,abs(N_est2),'-','color',[0.6350 0.0780 0.1840],'LineWidth',1.5);
h3_1 = semilogy(D_list(idx),abs(N_est2(idx)),'o','color',[0.6350 0.0780 0.1840],'LineWidth',1.5);
h3_2 = semilogy(D_list(1),abs(N_est2(1)),'-o','color',[0.6350 0.0780 0.1840],'LineWidth',1.5);


y2=10^(-1):0.1:10^3;
% x2=d_near+0.*y2; %% 产生一个和y2长度相同的x2数组
% plot(x2,y2,'--','color', [0 0 1],'LineWidth',1.5);

h=legend([h1_2,h3_2, h2_2], 'Accurate channel DoFs', 'DoFs estimated in [13]', ...
    'DoFs estimated in [12]', 'FontSize',13);
set(h,'Interpreter','latex','Location','southwest');

xlabel('Distance between BS and UE [m]','FontName', 'Times','FontSize',14);
ylabel('Degrees of Freedom','FontName', 'Times','FontSize',14);
grid on;


% % 创建 textbox
% annotation(figure1,'textbox',...
%     [0.426699999999999 0.810600465551482 0.20071429007394 0.0750950582580422],...
%     'Color',[1 0 0],...
%     'String','Near-Field',...
%     'FontWeight','bold',...
%     'FontSize',14,...
%     'FontName','Times',...
%     'FitBoxToText','off',...
%     'EdgeColor','none');

% % 创建 textbox
% annotation(figure1,'textbox',...
%     [0.691342857142855 0.811552846503866 0.182142861059734 0.0750950582580422],...
%     'String','Far-Field',...
%     'FontWeight','bold',...
%     'FontSize',14,...
%     'FontName','Times',...
%     'FitBoxToText','off',...
%     'EdgeColor','none');
% 
% % 创建 textbox
% annotation(figure1,'textbox',...
%     [0.343128571428569 0.613915692964367 0.245714291146823 0.0674904953390928],...
%     'Color',[0 0 1],...
%     'String','Rayleigh distance',...
%     'FontWeight','bold',...
%     'FontSize',12,...
%     'FontName','Times',...
%     'FitBoxToText','off',...
%     'EdgeColor','none');
% 
% % 创建 arrow
% annotation(figure1,'arrow',[0.578571428571428 0.635714285714286],...
%     [0.644761904761905 0.644761904761905],'Color',[0 0 1],'LineWidth',1);



% 'String','Near-Field'
